<?php

include("general_functions.php");

class Parser {
  public $remote_url;  // url of remote site
  public $script_url;  // url of this script
  
  public $html_array = null;  // an HTML file
  public $html_lines = null;  // significant html_array index nums

  public $cat_local_paths = 1;

  public $remote_url_base = null;
  public $remote_dir_path = null;

  public $tag;  
  public $HTML_path_delimeters;
  

  public function fetch_html() {
    // fetch the html file recieved from remote_url records each line of the 
    // file in the array 'html_array'

    $this->html_array = file($this->remote_url); 
  }

  
  public function print_html_array() {
    // print each line of the array 'html_array'

    foreach($this->html_array as $line) {
      echo $line;
    }
  }

    
  public function select_tag($tag) {
    // finds the index numbers of lines in 'html_array' that fall within the 
    // open and closing $tag, for example...
    // <body ... >
    // </body>
    //
    // $tag must be a tag with a separate closing tag in the syntax '</$tag>'

    $lines = array();
    $bgn_tag = "<".strtolower($tag);
    $end_tag = "</".strtolower($tag);
    $trigger = 0;
    $html_array = $this->html_array;

    for($x=0;$x<count($html_array);$x++) {
      $token = $html_array[$x];

      if (strstr(strtolower($token), $end_tag)) {
         $trigger = 0;
      }
      if ($trigger == 1) {
        array_push($lines, $x);
      }
      if (strstr(strtolower($token), $bgn_tag)) {
        $trigger = 1;
      }
    }
    $this->html_lines = $lines;
  }


  public function set_urltok($item) {
    // changes the value of the array '$HTML_path_delimeters' to the value of 
    // $item. If $item is a string and not an array, $item is pushed into 
    // '$HTML_path_delimeters'

    $value = array();
    if (is_array($item)) {
      $value = $item;
    } else {
      array_push($value, $item);
    }
    $this->HTML_path_delimeters = $value;
  }

  
  public function set_dirpth($dir) {
    // pulls file name off of a dir path assumes that $dir is a directory path
    // (ex. /foo/bar) and sets remote_dir_path to the value of dir if a filename
    // is found at the end of $dir's path, the file name is removed before 
    // setting $remote_dir_path

    $filename = null;
    $filename = basename($dir);
        
    if ($filename) {
      $dirpath = strpre($dir, $filename);
    } else {
      $dirpath = $dir;
    }  
    $this->remote_dir_path = $dirpath;
  }

  
  public function set_urlbse() {
    // sets the value of $remote_url_base...
    // $remote_url is default value assigned to $remote_url_base, but
    // if a 'base' href value is found in html_array, this base value is used

    $html_path_delimeters = array();
    array_push($html_path_delimeters, 'base href');
    $html_array = $this->html_array;
    $fpath = $this->remote_url;
    $lines = $this->html_lines;
    $base = null;
    
    // process each line of html
    for($x=0;$x<count($html_array);$x++) {
      $this_line = 0;
      if ($lines == null) {    // if no lines are specified,
        if($html_array[$x]) {  // and current line not empty
          $this_line = 1;      // trigger this line
        }                      // else, only trigger if 'lines'
      } else {                 // contains current line
        if(($html_array[$x]) && (in_array($x, $lines))) {
          $this_line = 1;      
        }
      }

      $delimeter = null;
      if ($this_line == 1) {
        $delimeter = items_in_string($html_path_delimeters, $html_array[$x]);
      }   
      if ($delimeter) {
        $base = get_url_following_delimeter($html_array[$x], 'href');
      }
    }
    
    if (is_null($base)) {
      $base = $this->remote_url.$this->remote_dir_path;
    }
    $this->remote_url_base = $base;
  }
  
  
  public function append_remote_url() {
    // where path delimeter is found,
    // remote path will be appended to 
    // - paths that consist of a dir path
    // - paths that consist of a single filename
    
    $html_path_delimeters = $this->HTML_path_delimeters;
    $html_array = $this->html_array;
    $fpath = $this->remote_url;
    $fbase = $this->remote_url_base;
    $lines = $this->html_lines;
    
    // process each line of html
    for($x=0;$x<count($html_array);$x++) {
      $this_line = 0;
      if ($lines == null) {    // if no lines are specified,
        if($html_array[$x]) {  // and current line not empty
          $this_line = 1;      // trigger this line
        }                      // else, only trigger if lines
      } else {                 // contains current line
        if(($html_array[$x]) && (in_array($x, $lines))) {
          $this_line = 1;      
        }
      }

      $delimeter = null;
      if ($this_line == 1) {
        $delimeter = items_in_string($html_path_delimeters, $html_array[$x]);
      }   

      // this only parses _FULL_ paths...
      if ($delimeter) {
        // if path contains foreign url
        $newline = null;
        $directive = strpre($delimeter, '=');
        $html_array[$x] = html_append($html_array[$x], $directive, $fbase, $fpath);
      }  
    }
    $this->html_array = $html_array;
  }
  
  public function append_line_href($line) {
    // concatanates string $base_url to urls in html_array that are associated
    // with HTML_path_delimeters
    //
    // example:
    //  if a line reads:
    //    <link rel="stylesheet" type="text/css" href="css/style.css" />
    //  it will be modified to:
    //    <link rel="stylesheet" type="text/css" href="$basecss/style.css" />
    //  else:
    //    no modification will occur
    //
    //      src="local/path",
    //     href="local/path",
    // template="local/path",
    //   action="local/path"

    $base_url = $this->script_url;

    $final_string = $line ? $line : null;              // string returned
    $temp_array   = $line ? split(' ', $line) : null;  // words in $line
    $temp_token   = null;                              // word from $line
    $new_line     = null;
    $bgn;  // ex: src="
    $path; // ex: local/path
    
    $html_path_delimeters = $this->HTML_path_delimeters;

    for($i=0;$i<count($temp_array);$i++) {
      $temp_token = $temp_array[$i];
      $delimeter = items_in_string($html_path_delimeters, $temp_token);
      
      if ($delimeter) {    
        list($bgn, $path) = split($delimeter, $temp_token);
        if (count(split('http://', $temp_token)) > 1) {
          //do nothing
        }else{
          $temp_token = $bgn.$delimeter.$base_url.$path;
        }
        $temp_array[$i] = $temp_token;
      }
    }

    //combine items of temp_array into new line
    for($i=0;$i<count($temp_array);$i++) {
      $new_line = $new_line.' '.$temp_array[$i];
    }
    if ($new_line) {
        $line = $new_line;
    }
  return $new_line;
  }

  
  public function chngto_remote_url() {
    // looks at elements in html_array and replaces occurences of $remote_url
    // to $script_url
   
    $html_path_delimeters = $this->HTML_path_delimeters;
    $html_array = $this->html_array;
    $fpath = $this->remote_url_base;
    $fbase = $this->remote_url_base;
    $npath = $this->script_url;
    $lines = $this->html_lines;
    
    // process each line of html
    for($x=0;$x<count($html_array);$x++) {
      $this_line = 0;
      if ($lines == null) {    // if no lines are specified,
        if($html_array[$x]) {  // and current line not empty
          $this_line = 1;      // trigger this line
        }                      // else, only trigger if lines
      } else {                 // contains current line
        if(($html_array[$x]) && (in_array($x, $lines))) {
          $this_line = 1;      
        }
      }

      $delimeter = null;
      if ($this_line == 1) {
        $delimeter = items_in_string($html_path_delimeters, $html_array[$x]);
      }   

      // this only parses _FULL_ paths...
      if ($delimeter) {
        // if path contains foreign url
        $newline = null;
        if (strpos($html_array[$x], $fpath)) {
          $html_array[$x] = str_remove($fpath, $html_array[$x]); // remove base
          $html_array[$x] = html_encode($html_array[$x], 'href'); // encode rest
          $html_array[$x] = html_append($html_array[$x], 'href', $npath, $npath);
        } else {
            $html_array[$x] = html_encode($html_array[$x], 'href');
            $html_array[$x] = html_append($html_array[$x], 'href', $npath, $npath);
        }
      }
    }
    $this->html_array = $html_array;
  }
}

?>
